#ifndef ITOOL_INFO_H
#define ITOOL_INFO_H

#include <qstring.h>
#include <qrect.h>

struct IToolInfo
{
	/**
	 * The hot rect for tool.
	 */
	QRect rc;
	/**
	 * The command for tool.
	 */
	QString command;
	/**
	 * The menu's and statusbar's string for runnig this tool.
	 */
	QString menuString;
	/**
	 * The hot-key for tool.
	 */
	QString hotKey;
	QString toolTip;

	IToolInfo(const QRect &r, const char *cmd, const char *mStr,
			const char *hk = 0, 
			const char *tt = 0):
		rc(r), command(cmd), menuString(mStr), hotKey(hk), toolTip(tt){}
}; /* struct IToolInfo */
#endif
