/***************************************************************************
                          qcentralwidget.cpp  -  description
                             -------------------
    begin                : Sun Apr 14 2002
    copyright            : (C) 2002 by Vadim A. Khohlov
    email                : xvadim@teko.kherson.ua
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qapp.h>
#include <qpixmap.h>
#include <qevent.h>
#include <qmainwindow.h>
#include <qstatusbar.h>

#include "qcentralwidget.h"
#include "icecc.h"
#include "tools.h"

QCentralWidget::QCentralWidget(QPtrVector<IToolInfo> &t,
		QWidget *parent, const char *name ):
QWidget(parent,name), aTools(t),prevToolHighlighted(t.count() + 1)
{
    setMouseTracking(true);
}//constructor

QCentralWidget::~QCentralWidget()
{
}//destructor

/** No descriptions */
void QCentralWidget::mouseReleaseEvent (QMouseEvent *mouseEvent)
{
    for(uint i = 0; i < aTools.count(); i++)
        if(aTools[i]->rc.contains(mouseEvent->pos()))
        {
            ((IceCCApp*)parentWidget())->runTool(i);
            break;
        }/* if(toolRect[i].contains(mouseEvent->pos())) */
}/* IceCCApp::mousePressEvent ( QMouseEvent * ) */

/** No descriptions */
void QCentralWidget::mouseMoveEvent( QMouseEvent *mouseEvent)
{
    for(uint i = 0; i < aTools.count(); i++)
        if(aTools[i]->rc.contains(mouseEvent->pos()))
        {
            if(i != prevToolHighlighted)
            {
				//debug("%d", i);
                prevToolHighlighted = i;
                ((QMainWindow*)parentWidget())->statusBar()->message(aTools[i]->menuString);
            }/* if(i != prevToolHighlighted) */
            break;
        }/* if(toolRect[i].contains(mouseEvent->pos())) */
}/* QCentralWidget::mouseMoveEvent ( QMouseEvent * ) */
